<?php
  error_reporting(E_ALL ^ E_WARNING ^ E_NOTICE);
  include_once "fefunctions.php";
  start_session();
  $ci = new client_info();
  $os = $ci->get_client_platform();
  $weekdaysArr = "";
?>
<!--
   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

-->
<html>
<head>
  <meta http-equiv='content-type' content='text/html; charset=UTF-8'>
  <title>HP Insight Diagnostics</title>
  <link rel='stylesheet' type='text/css' href='stylesheets/main.css'>
  <style style='text/css'> body { background:white; } 

	#scheduleIt {
		position:absolute;
		height:200px;
		width:500px;
		background-color:#F4F4F4;
		border:1px solid #333;
		font-family:verdana, sans-serif;
		font-size:10px;
		}

	#scheduleTitle {
		margin:2px;
		padding:2px;
		width:492px;
		color:black;
		background-color:#cccccc;
		cursor:default;
		}
  </style>
  <script language="Javascript">
  function hideScheduledMessage()
  {
    document.getElementById('scheduleIt').style.display = 'none';
    document.getElementById('scheduleIt').style.visibility = 'hidden';
  }
  </script>
</head>
<body>
<form name="diagIDForm" method=POST>
<?php

if ($HTTP_POST_VARS["send"] == "1")
{
  $lang = GetLanguage();
  $result = loadTransArray($lang); // do front-end translations
  
  $idErrors = "";
  $idStatus = "";
  $idCommand = sprintf("<scheduleProcess hour='%s' minute='%s' mode='%s' weekdays='%s' months='%s' monthdays='%s'><diagID language='%s' surveyCapture='1'/></scheduleProcess>", $HTTP_POST_VARS["scheduleHour"], $HTTP_POST_VARS["scheduleMinute"], $HTTP_POST_VARS["scheduleMode"], $HTTP_POST_VARS["scheduleWeekdays"], $HTTP_POST_VARS["scheduleMonths"], $HTTP_POST_VARS["scheduleMonthdays"],$lang);
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $idCommand, $idStatus, $idErrors);
}
?>
<input type='hidden' name='send' value='0'>
<input type='hidden' name='scheduleType' value='1'>
<input type='hidden' name='scheduleHour' value=''/>
<input type='hidden' name='scheduleMinute' value=''/>
<input type='hidden' name='scheduleMode' value=''/>
<input type='hidden' name='scheduleWeekdays' value=''/>
<input type='hidden' name='scheduleMonths' value=''/>
<input type='hidden' name='scheduleMonthdays' value=''/>

</form>
<script language=JavaScript>
function checkAllWeekdays(isChecked)
{
<?php
  for ($wd=0; $wd < 7; $wd++)
    printf("  document.scheduleForm.weekday%d.checked = isChecked;\n", $wd);
?>
}
function checkAllMonths(isChecked)
{
<?php
  for ($m=1; $m < 13; $m++)
    printf("  document.scheduleForm.month%d.checked = isChecked;\n", $m);
?>
}
function checkAllMonthDays(isChecked)
{
<?php
  for ($md=1; $md < 32; $md++)
    printf("  document.scheduleForm.monthday%d.checked = isChecked;\n", $md);
?>
}
function disableAllWeekdays(isDisabled)
{
<?php
  for ($wd=0; $wd < 7; $wd++)
    printf("  document.scheduleForm.weekday%d.disabled = isDisabled;\n", $wd);
?>
}
function disableAllMonths(isDisabled)
{
<?php
  for ($m=1; $m < 13; $m++)
    printf("  document.scheduleForm.month%d.disabled = isDisabled;\n", $m);
?>
}
function disableAllMonthDays(isDisabled)
{
<?php
  for ($md=1; $md < 32; $md++)
    printf("document.scheduleForm.monthday%d.disabled = isDisabled;\n", $md);
?>
}
function scheduleModeChange(newMode)
{
  if(newMode == 'weekly')
  {
    disableAllMonths(true);
    disableAllMonthDays(true);
    document.getElementById('monthDayDiv').style.display = 'none';
    document.getElementById('monthDayDiv').style.visibility = 'hidden';
    <?php
    if (!strstr($os, "Windows"))
    {
      printf("document.getElementById('monthField').style.display = 'none';\n");
      printf("document.getElementById('monthField').style.visibility = 'hidden';\n");
    }  
    ?>
    document.getElementById('weekdayField').style.display = 'inline';
    document.getElementById('weekdayField').style.visibility = 'visible';
    disableAllWeekdays(false);
  }
  else if(newMode == 'monthly')
  {
    disableAllWeekdays(true);
    document.getElementById('weekdayField').style.display = 'none';
    document.getElementById('weekdayField').style.visibility = 'hidden';
    <?php
    if (!strstr($os, "Windows"))
    {
      printf("document.getElementById('monthField').style.display = 'inline';\n");
      printf("document.getElementById('monthField').style.visibility = 'visible';\n");
    }  
    ?>
    document.getElementById('monthDayDiv').style.display = 'inline';
    document.getElementById('monthDayDiv').style.visibility = 'visible';
    disableAllMonths(false);
    disableAllMonthDays(false);
  }
}
function scheduleIt()
{
<?php
  if (strstr($_SESSION["page"], "survey"))
    printf("  var type = 'diagID';\n");
  else
    printf("  var type = 'diagRun';\n");
?>
  var formName = type + "Form";
  
  document.forms[formName].send.value = "1";
  document.forms[formName].scheduleType.value = type;
  document.forms[formName].scheduleMode.value = document.scheduleForm.scheduleMode.value;
  if (document.scheduleForm.scheduleMode.value == "weekly")
  {
    var weekdaysStr = "";
    for (var day=0; day < 7; day++)
    {
      var weekdayEl = "weekday" + day;
      if (window.document.getElementById(weekdayEl).checked)
        weekdaysStr = weekdaysStr + day + ',';      
    }
    document.forms[formName].scheduleWeekdays.value = weekdaysStr;    
  }
  else if (document.scheduleForm.scheduleMode.value == "monthly")
  {
    var monthsStr = "";
    for (var month=1; month < 13; month++)
    {
      var monthEl = "month" + month;
      if (window.document.getElementById(monthEl).checked)
         monthsStr = monthsStr + month + ',';
    }
    document.forms[formName].scheduleMonths.value = monthsStr;

    var monthdaysStr = "";
    for (var monthday=1; monthday < 32; monthday++)
    {
      var monthdayEl = "monthday" + monthday;
      if (window.document.getElementById(monthdayEl).checked)
         monthdaysStr = monthdaysStr + monthday + ',';
    }
    document.forms[formName].scheduleMonthdays.value = monthdaysStr;    
  }
  document.forms[formName].scheduleHour.value = document.scheduleForm.hour.value;
  document.forms[formName].scheduleMinute.value = document.scheduleForm.minute.value;

  document.forms[formName].send.value = "1";
  document.forms[formName].submit();
  window.close();
}
</script>
<form name='scheduleForm' method=post>
<?php
    
  $scheduleError = "";
  $scheduleString = "";
  $scheduleThisAttributes = "";
  if ($_SESSION["page"] == "survey.php")
  {
    $scheduleThis = "diagID";
    $scheduleThisAttributes = " surveyCapture='1'";
  }
  else
   $scheduleThis = "diagRun";
?>

<div id='scheduleIt' style='left:230px; top:165px;Visibility:hidden; display:none;height:320px' name='scheduleIt'>
  <div id='scheduleTitle' width=100%>
<?php
  if ($scheduleThis == "diagID")
    printf("%s\n", TR("MSG_SCHEDULE_SURVEY_CAPTURE"));
  else if ($scheduleThis == "diagRun")
    printf("%s\n", TR("MSG_SCHEDULE_TESTING"));
?>      
  </div>
  <div id='scheduleContainerIt'>
  
<?php
  $getScheduleString = sprintf("<getProcessSchedule><%s%s/></getProcessSchedule>", $scheduleThis, $scheduleThisAttributes);
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $getScheduleString, $scheduleString, $scheduleError);

  $xmldoc = new DomDocument($scheduleString);
  //echo htmlentities($xmldoc->html_dump_mem());
  $processSchedule = $xmldoc->document_element();
  $hour = $processSchedule->get_attribute("hour");
  $minute = $processSchedule->get_attribute("minute");
  $mode = $processSchedule->get_attribute("mode");
  if ($mode == "")
    $mode = "weekly";

  $weekdaysStr =  $processSchedule->get_attribute("weekdays");
  if ($weekdaysStr != "")
  {
    $weekdaysArr = ParseCronField($weekdaysStr, 0, 6);
  }
  else
  {
    $monthsArr = ParseCronField($processSchedule->get_attribute("months"), 1, 12);
    $monthdaysArr = ParseCronField($processSchedule->get_attribute("monthdays"), 1, 31);
  }

  if ($scheduleString == "" || strstr($scheduleString, "Invalid command"))
  { // scedule has not been set - display default
    printf("<br>%s\n<hr>\n<center>\n", TR("MSG_NOT_CURRENTLY_SCHEDULED"));
    
  }

  printf("<br><br><center>%s:\n", TR("MSG_SELECT_SCHEDULE_MODE"));
  printf("<select name=scheduleMode onChange='scheduleModeChange(options[selectedIndex].value)'>\n");
  printf("<option value='weekly'");
  if ($mode == "weekly")
    printf(" selected");
  printf(">%s</option>\n", TR("MSG_WEEKLY"));
  printf("<option value='monthly'");
  if ($mode == "monthly")
    printf(" selected");
  printf(">%s</option>\n", TR("MSG_MONTHLY"));
  printf("</select>\n<br>\n<br>\n");

  $weekdays = array("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
  printf("<div id='weekdayField' ");
  if ($mode == "weekly")
    printf("style='visiblity:visible; display:inline'>\n");
  else
    printf("style='visiblity:hidden; display:none'>\n");
  printf("<fieldset><legend>%s</legend><table>\n<tr>", TR("MSG_SELECT_WEEKDAYS"));
  for ($d=0; $d < 7; $d++)
  {
    if ($d == 4)
      printf("</tr>\n<tr>\n");
    printf("<td><input type=checkbox name='weekday%d' id='weekday%d'", $d,$d);
    if ($weekdaysArr[$d])
      printf(" checked");
    printf(">%s&nbsp;&nbsp;</td>\n", TR($weekdays[$d]));
  }
  printf("</tr></table>\n");
  
  printf("<a href='#' onClick='checkAllWeekdays(true)'>%s</a>&nbsp;&nbsp;&nbsp;&nbsp;<a href='#' onClick='checkAllWeekdays(false)'>%s</a>\n", TR("MSG_CHECK_ALL"), TR("MSG_UNCHECK_ALL"));
  printf("</fieldset><br>\n</div>");

  printf("<div id='monthField' ");
  if ($mode == "monthly" && !strstr($os, "Windows"))
    printf("style='visiblity:visible; display:inline'>\n");
  else
    printf("style='visiblity:hidden; display:none'>\n");
  printf("<fieldset><legend>%s</legend>\n", TR("MSG_SELECT_MONTHS"));
  $months = array("","January","February","March","April","May","June","July","August","September","October","November","December");
  for ($m=1; $m < 13; $m++)
  {
    printf("<input type=checkbox name='month%d' id='month%d'",$m,$m);
    if (strstr($os,"Windows"))
    {
      printf(" checked disabled");
    }
    else if ($monthsArr[$m])
      printf(" checked");
    printf(">%s&nbsp;&nbsp;\n",TR($months[$m]));
  }
  printf("<br><a href='#' onClick='checkAllMonths(true)'>%s</a>&nbsp;&nbsp;&nbsp;&nbsp;<a href='#' onClick='checkAllMonths(false)'>%s</a>\n", TR("MSG_CHECK_ALL"), TR("MSG_UNCHECK_ALL"));  
  printf("</fieldset><br>");
  printf("</div><div name='monthDayDiv' id='monthDayDiv' ");
  if ($mode == "monthly")
    printf("style='visiblity:visible; display:inline'>\n");
  else
    printf("style='visiblity:hidden; display:none'>\n");

  printf("<fieldset><legend>%s</legend>\n", TR("MSG_SELECT_MONTHDAYS"));
  for ($md=1; $md < 32; $md++)
  {
    printf("<input type=checkbox name='monthday%d' id='monthday%d'", $md, $md);
    if ($monthdaysArr[$md])
      printf(" checked");
    printf(">%d&nbsp;&nbsp;\n", $md);
  }
    
?>
<br><a href='#' onClick='checkAllMonthDays(true)'><?php echo TR("MSG_CHECK_ALL");?></a>&nbsp;&nbsp;&nbsp;&nbsp;<a href='#' onClick='checkAllMonthDays(false)'><?php echo TR("MSG_UNCHECK_ALL"); ?></a></fieldset><br>
</div>
<?php echo TR("MSG_SELECT_START_TIME"); ?><br>
<table><tr><td><?php echo TR("MSG_HOUR"); ?></td><td><?php TR("MSG_MINUTE"); ?></td></tr>
<tr><td><select name='hour'>
<?php
  for ($h=0; $h < 24; $h++)
  {
    printf("<option name='%d' value='%d'", $h, $h);
    if ($hour == $h)
      printf(" selected");
    printf(">%d</option>\n", $h);
  }
?>
</select>&nbsp;:</td><td><select name='minute'>
<?php
  for ($m=0; $m < 60; $m++)
  {
    printf("<option name='%d' value='%d'", $m, $m);
    if ($minute == $m)
      printf(" selected");
    printf(">%d</option>\n", $m);
  }
?>  
</select></td></tr></table><br>
<?php  
  printf("<table border=0 cellspacing=5>\n  <tr>\n    <td>%s</td>\n    <td>%s</td>\n  </tr>\n</table>\n", MakeButton(TR("MSG_OK"),"scheduleIt();"), MakeButton(TR("MSG_CANCEL"),"document.getElementById('scheduleIt').style.display = 'none';document.getElementById('scheduleIt').style.visibility = 'hidden';"));

?>
  </div>
</div>

</form>

</body>
</html>
